
/* The program is designed to implement the game "CHAIN REACTION".
Group Members are:
1:Ankush Mukherjee(Team leader)
2:Akash Chikhalikar
3:Prajesh Jangale
4:Aditya Kalra
*/
#include <simplecpp>
#include <cstdio>
#include <cmath>
using namespace std;
class game                    //Creates a variable type "game"
{

public:
    int prev[10][6];
    int **grid ;
    game()
    {
        for(int i=0; i<10; i++)
            for(int j=0; j<6; j++)
                prev[i][j]=0;
        grid =new int*[10];
        for(int i=0; i<10; i++)
        {
            grid[i]=new int[6];
        }
    }

    void display();
    void display(int grid[10][6]);
    int checkWin(int **grid,int player_no);
    int isBorder(int i,int j);
    int isCorner(int i,int j);
    void add(int i,int j,int **grid,int player_no);
    ~game()
    {
        delete []grid;
    }
};
void game::display()
/*This function displays the 2 D grid.
Empty boxes are kept blank.
When a player clicks within the dimensions of a particular box
the orbs corresponding to player's colour appear in that box.
Green coloured orbs correspond to Player 1.
Blue coloured orbs correspond to Player 2.
*/
{
    for(int i=0; i<6; i++)
    {

        for(int j=0; j<10; j++)
        {
            if(this->prev[j][i]!=this->grid[j][i])  //Checks the difference between the current display
                //and the previous step display
            {
                Rectangle r(130+40*i,90+40*j,35,35);
                r.setColor(COLOR("white"));
                r.setFill();
                r.imprint();
                if(this->grid[j][i]/10==1)
                {
                    switch (this->grid[j][i]%10)    //Determines the number of orbs within a particular box.
                    {
                    case 1:
                    {
                        Circle c1(130+40*i,90+40*j,5);
                        c1.setColor(COLOR("green"));
                        c1.setFill();
                        c1.imprint();
                        break;
                    }
                    case 2:
                    {
                        Circle c1(130+40*i+5,90+40*j,5),c2(130+40*i-5,90+40*j,5);
                        c1.setColor(COLOR("green"));
                        c1.setFill();
                        c2.setColor(COLOR("green"));
                        c2.setFill();
                        c1.imprint();
                        c2.imprint();
                        break;
                    }
                    case 3:
                    {
                        Circle c1(130+40*i+5,90+40*j+5,5),c2(130+40*i-5,90+40*j+5,5),c3(130+40*i,90+40*j-5,5);
                        c1.setColor(COLOR("green"));
                        c1.setFill();
                        c2.setColor(COLOR("green"));
                        c2.setFill();
                        c3.setColor(COLOR("green"));
                        c3.setFill();
                        c1.imprint();
                        c2.imprint();
                        c3.imprint();
                        break;
                    }
                    case 4:
                    {
                        Circle c1(130+40*i+5,90+40*j,5),c2(130+40*i-5,90+40*j,5),c3(130+40*i,90+40*j+5,5),c4(130+40*i,90+40*j-5,5);
                        c1.setColor(COLOR("green"));
                        c1.setFill();
                        c2.setColor(COLOR("green"));
                        c2.setFill();
                        c3.setColor(COLOR("green"));
                        c3.setFill();
                        c4.setColor(COLOR("green"));
                        c4.setFill();
                        c1.imprint();
                        c2.imprint();
                        c3.imprint();
                        c4.imprint();
                    }
                    }
                }
                else
                {
                    switch (this->grid[j][i]%10)
                    {
                    case 1:
                    {
                        Circle c1(130+40*i,90+40*j,5);
                        c1.setColor(COLOR("blue"));
                        c1.setFill();
                        c1.imprint();
                        break;
                    }
                    case 2:
                    {
                        Circle c1(130+40*i+5,90+40*j,5),c2(130+40*i-5,90+40*j,5);
                        c1.setColor(COLOR("blue"));
                        c1.setFill();
                        c2.setColor(COLOR("blue"));
                        c2.setFill();
                        c1.imprint();
                        c2.imprint();
                        break;
                    }
                    case 3:
                    {
                        Circle c1(130+40*i+5,90+40*j+5,5),c2(130+40*i-5,90+40*j+5,5),c3(130+40*i,90+40*j-5,5);
                        c1.setColor(COLOR("blue"));
                        c1.setFill();
                        c2.setColor(COLOR("blue"));
                        c2.setFill();
                        c3.setColor(COLOR("blue"));
                        c3.setFill();
                        c1.imprint();
                        c2.imprint();
                        c3.imprint();
                        break;
                    }
                    case 4:
                    {
                        Circle c1(130+40*i+5,90+40*j,5),c2(130+40*i-5,90+40*j,5),c3(130+40*i,90+40*j+5,5),c4(130+40*i,90+40*j-5,5);
                        c1.setColor(COLOR("blue"));
                        c1.setFill();
                        c2.setColor(COLOR("blue"));
                        c2.setFill();
                        c3.setColor(COLOR("blue"));
                        c3.setFill();
                        c4.setColor(COLOR("blue"));
                        c4.setFill();
                        c1.imprint();
                        c2.imprint();
                        c3.imprint();
                        c4.imprint();
                    }
                    }
                }
            }
        }


    }


    for(int i=0; i<6; i++)
    {

        for(int j=0; j<10; j++)
        {
            this->prev[j][i]=this->grid[j][i];
        }
    }
}
void game::display(int grid[10][6])
/*This function also displays the 2 D grid.
Empty boxes are kept blank.
When a player clicks within the dimensions of a particular box
the orbs corresponding to player's colour appear in that box.
Green coloured orbs correspond to Player 1.
Blue coloured orbs correspond to Player 2.
The concept of function overloading is used here.
*/
{

    for(int i=0; i<6; i++)
    {

        for(int j=0; j<10; j++)
        {
            if(prev[j][i]!=grid[j][i])
            {
                Rectangle r(130+40*i,90+40*j,35,35);
                r.setColor(COLOR("white"));
                r.setFill();
                r.imprint();
                if(grid[j][i]/10==1)
                {
                    switch (grid[j][i]%10)         //Determines the number of orbs in a particular box
                    {
                    case 1:
                    {
                        Circle c1(130+40*i,90+40*j,5); //Creates a circle at centre at grid[j][i]
                        c1.setColor(COLOR("green"));   //Changes the colour of orb to green
                        c1.setFill();                  //Fills the entire space occupied by the orb with its boundary colour
                        c1.imprint();
                        break;
                    }
                    case 2:
                    {
                        Circle c1(130+40*i+5,90+40*j,5),c2(130+40*i-5,90+40*j,5);
                        c1.setColor(COLOR("green"));
                        c1.setFill();
                        c2.setColor(COLOR("green"));
                        c2.setFill();
                        c1.imprint();
                        c2.imprint();
                        break;
                    }
                    case 3:
                    {
                        Circle c1(130+40*i+5,90+40*j+5,5),c2(130+40*i-5,90+40*j+5,5),c3(130+40*i,90+40*j-5,5);
                        c1.setColor(COLOR("green"));
                        c1.setFill();
                        c2.setColor(COLOR("green"));
                        c2.setFill();
                        c3.setColor(COLOR("green"));
                        c3.setFill();
                        c1.imprint();
                        c2.imprint();
                        c3.imprint();
                        break;
                    }
                    case 4:
                    {
                        Circle c1(130+40*i+5,90+40*j,5),c2(130+40*i-5,90+40*j,5),c3(130+40*i,90+40*j+5,5),c4(130+40*i,90+40*j-5,5);
                        c1.setColor(COLOR("green"));
                        c1.setFill();
                        c2.setColor(COLOR("green"));
                        c2.setFill();
                        c3.setColor(COLOR("green"));
                        c3.setFill();
                        c4.setColor(COLOR("green"));
                        c4.setFill();
                        c1.imprint();
                        c2.imprint();
                        c3.imprint();
                        c4.imprint();
                    }
                    }
                }
                else
                {
                    switch (grid[j][i]%10)
                    {
                    case 1:
                    {
                        Circle c1(130+40*i,90+40*j,5);
                        c1.setColor(COLOR("blue"));
                        c1.setFill();
                        c1.imprint();
                        break;
                    }
                    case 2:
                    {
                        Circle c1(130+40*i+5,90+40*j,5),c2(130+40*i-5,90+40*j,5);
                        c1.setColor(COLOR("blue"));
                        c1.setFill();
                        c2.setColor(COLOR("blue"));
                        c2.setFill();
                        c1.imprint();
                        c2.imprint();
                        break;
                    }
                    case 3:
                    {
                        Circle c1(130+40*i+5,90+40*j+5,5),c2(130+40*i-5,90+40*j+5,5),c3(130+40*i,90+40*j-5,5);
                        c1.setColor(COLOR("blue"));
                        c1.setFill();
                        c2.setColor(COLOR("blue"));
                        c2.setFill();
                        c3.setColor(COLOR("blue"));
                        c3.setFill();
                        c1.imprint();
                        c2.imprint();
                        c3.imprint();
                        break;
                    }
                    case 4:
                    {
                        Circle c1(130+40*i+5,90+40*j,5),c2(130+40*i-5,90+40*j,5),c3(130+40*i,90+40*j+5,5),c4(130+40*i,90+40*j-5,5);
                        c1.setColor(COLOR("blue"));
                        c1.setFill();
                        c2.setColor(COLOR("blue"));
                        c2.setFill();
                        c3.setColor(COLOR("blue"));
                        c3.setFill();
                        c4.setColor(COLOR("blue"));
                        c4.setFill();
                        c1.imprint();
                        c2.imprint();
                        c3.imprint();
                        c4.imprint();
                    }
                    }
                }
            }
        }


    }


    for(int i=0; i<6; i++)
    {

        for(int j=0; j<10; j++)
        {
            prev[j][i]=grid[j][i];
        }
    }
}
int game::checkWin(int **grid,int player_no)
/*
This function checks whether player player_no has already won the game or not.
Note that player_no only takes two values "1 and 2".
*/
{

    for(int i=0; i<10; i++)
        for(int j=0; j<6; j++)
            if((grid[i][j]!=0)&&(player_no!=(grid[i][j]/10)))
                return 0;
    return 1;
}

int game::isBorder(int i,int j)       //checks whether position (i,j) is on the border of the grid or not
{
    //which in turn helps in determining the critical mass for a particular box.
    if(i==0||i==9||j==0||j==5)return 1;
    else return 0;
}

int game::isCorner(int i,int j)       //checks whether position ( i ,j ) is a corner of the grid or not
{
    //which in turn helps in determining the critical mass for a particular box.
    if(i==0&&j==0)
        return 1;
    if(i==0&&j==5)
        return 1;
    if(i==9&&j==0)
        return 1;
    if(i==9&&j==5)
        return 1;

    return 0;
}
void game::add(int i,int j,int **grid,int player_no)
/*
Adds a orb of player player_no to box (i,j) of grid
If mass of orbs exceeds the critical mass the orbs
explode and all previously existing orbs in surrounding
boxes are converted to orbs of player player_no
i.e their colour changes
*/
{

    int no_balls=grid[i][j]%10;//stores the number of orbs in the box (i,j) of the grid
    ++no_balls;
    display();
    grid[i][j]=player_no*10+no_balls;
    display();
    //considering the case when the ball is added to corner
    if((isCorner(i,j)&&no_balls==1)||(!isCorner(i,j)&&isBorder(i,j)&&no_balls<=2)||(!isBorder(i,j)&&no_balls<=3))
        return;
    if(checkWin(grid,player_no))
    {
        return;
    }
    grid[i][j]=0;

    if(isCorner(i,j))
    {
        if(i==0&&j==0)
        {
            add(0,1,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(1,0,grid,player_no);
            display();
        }
        else if(i==0&&j==5)
        {
            add(0,4,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(1,5,grid,player_no);
            display();
        }
        else if(i==9&&j==0)
        {
            add(9,1,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(8,0,grid,player_no);
            display();
        }
        else
        {
            add(9,4,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(8,5,grid,player_no);
            display();
        }

    }
    else if(isBorder(i,j)) //considering the case when orb is added to box on border other than corners
    {
        if(i==0)

        {
            add(0,j-1,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(1,j,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(0,j+1,grid,player_no);
            display();
        }
        else if(i==9)
        {
            add(9,j-1,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(8,j,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(9,j+1,grid,player_no);
            display();
        }
        else if(j==0)
        {
            add(i-1,0,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(i,1,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(i+1,0,grid,player_no);
            display();
        }
        else
        {
            add(i-1,5,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(i,4,grid,player_no);
            display();
            if(!checkWin(grid,player_no))
                add(i+1,5,grid,player_no);
            display();
        }
    }
    else
    {
        //ball is added to box in the interior
        add(i,j-1,grid,player_no);
        display();
        if(!checkWin(grid,player_no))
            add(i,j+1,grid,player_no);
        display();
        if(!checkWin(grid,player_no))
            add(i+1,j,grid,player_no);
        display();
        if(!checkWin(grid,player_no))
            add(i-1,j,grid,player_no);
        display();
    }


}




int validateInput(int **grid,int i ,int j, int player_no)
//validates the input.
{

    if(i<1||i>10||j<1||j>6)
        return 0;
    //the coordinates  are not valid
    if((grid[i-1][j-1]==0)||((grid[i-1][j-1]/10)==player_no))
        return 1;
    else
        return 0;
}

/*
The main function accepts input in the form of clicks
and checks the validity of the input.
*/

int main()
{
    bool newgame=true;
    initCanvas("CHAIN REACTIONS",500,500);
    do
    {
        if(newgame==false)
        {
            Rectangle blank(250,250,490,490);
            blank.setColor(COLOR("white"));
            blank.setFill();
            blank.imprint();
        }
        for(int i=1; i<7; i++)
        {
            for(int j=1; j<11; j++)
            {
                Rectangle r(90+40*i,50+40*j,40,40);
                r.imprint();

            }
        }

        Text tt(150,40,"ONE PLAYER");
        tt.imprint();
        Rectangle r_option1(150,40,100,20);
        r_option1.setColor(COLOR("red"));
        r_option1.imprint();

        Text Tt(290,40,"TWO PLAYER");
        Tt.imprint();
        Rectangle r_option2(290,40,100,20);
        r_option2.setColor(COLOR("red"));
        r_option2.imprint();
        float X,Y;
        int choice;
        while(true)
        {
            int inp=getClick();
            X=inp/65536;
            Y=inp%65536;
            if((X<172.5)&&(X>127.5)&&(Y<50)&&(Y>30))
            {
                choice=1;
                Text t1(100,480,"PLAYER1-COMPUTER");
                t1.imprint();
                Circle c1(180,480,5);
                c1.setColor(COLOR("green"));
                c1.setFill();
                c1.imprint();
                Text t2(353,480,"PLAYER");
                t2.imprint();
                Circle c2(390,480,5);
                c2.setColor(COLOR("blue"));
                c2.setFill();
                c2.imprint();

                break;
            }
            else if((X>240)&&(X<340)&&(Y<50)&&(Y>30))
            {
                choice=0;
                Text t1(110,480,"PLAYER-1");
                t1.imprint();
                Circle c1(149,480,5);
                c1.setColor(COLOR("green"));
                c1.setFill();
                c1.imprint();
                Text t2(353,480,"PLAYER-2");
                t2.imprint();
                Circle c2(395,480,5);
                c2.setColor(COLOR("blue"));
                c2.setFill();
                c2.imprint();

                break;
            }
            else
                continue;

        }
        r_option1.setColor(COLOR("white"));
        r_option1.setFill();
        r_option1.imprint();

        r_option2.setColor(COLOR("white"));
        r_option2.setFill();
        r_option2.imprint();



        Text t1(150,40,"UNDO");                   //Creates a box for function "UNDO"
        Rectangle r_undo(150,40,45,20);
        r_undo.setColor(COLOR("red"));


        t1.imprint();


        r_undo.imprint();



        if(choice==1)
        {
            r_undo.setColor(COLOR("white"));
            r_undo.setFill();
            r_undo.imprint();

        }


        wait(1);


        int i=0,j=0,k=0,l=0;                       //Initializes all the running variables to zero.
        bool undo=true;
        game ob;
        int no=1;
        if(ob.grid==NULL)
        {
            cout<<"Memory allocation failure";
            return -1;
        }



        for(int i=0; i<10; i++)
        {
            if(ob.grid[i]==NULL)
            {
                cout<<"Memory allocation failure";
                return -1;
            }
            for(int j=0; j<6; j++)
                ob.grid[i][j]=0;

        }

        int count=0;

        FILE *history = fopen("historydata","wb+");//This function stores thesteps of the array

        int t[10][6];                            //Function of this array is to store the previous step configuration.
        for(int i=0; i<10; i++)
            for(int j=0; j<6; j++)
            {
                t[i][j]=0;
            }
        int size=sizeof(t);
        fwrite(t,size,1,history);
        do
        {
            ++count;
            no=1-no;
            float x,y;
            while(true)
            {
                if(choice==0||no==1)
                {
                    int v = getClick();//accepting click input
                    x=v/65536,y=v%65536;

                }
                else
                {
                    x=rand()%241+110.1;
                    y=rand()%401+70.1;

                }

                if((x<172.5)&&(x>127.5)&&(y<50)&&(y>30)&&(count!=1)&&(undo==true)&&(choice==0))
                {
                    for(int i=0; i<10; i++)
                        for(int j=0; j<6; j++)
                            ob.grid[i][j]=t[i][j];
                    no=1-no;
                    ob.display();                //display current configuration of the game.
                    count--;
                    undo=false;
                }
                else if((x<110)||(x>350)||(y<70)||(y>470))
                {
                    continue;
                }

                else
                {
                    k=floor((x-110)/40);
                    l=floor((y-70)/40);
                    if(validateInput(ob.grid,l+1,k+1,no+1)==0)

                    {

                        continue;

                    }
                    else
                    {
                        if((choice==1)&&(count%2==1))
                        {
                            Rectangle r(90+40*(k+1),50+40*(l+1),40,40);
                            r.setColor(COLOR("green"));
                            r.imprint();
                            wait(0.5);
                            Rectangle r1(90+40*(k+1),50+40*(l+1),40,40);
                            r1.imprint();
                        }
                        for(int i=0; i<10; i++)
                            for(int j=0; j<6; j++)
                                t[i][j]=ob.grid[i][j];

                        fwrite(t,size,1,history);
                        break;
                    }
                }
            }


            i=l;
            j=k;
            ob.add(i,j,ob.grid,no+1);


            ob.display();//print current configuration of array

            if(count>2)
                if(ob.checkWin(ob.grid,no+1))
                {

                    break;;
                }


            fwrite(t,size,1,history);
            undo=true;

        }
        while(count<=1||(!ob.checkWin(ob.grid,no+1)));



        if(no+1==1)
        {
            Text t3(250,10,"WINNER - PLAYER 1");

            t3.imprint();


        }
        else
        {
            Text t4(250,10,"WINNER - PLAYER 2");
            t4.imprint();
        }
        Rectangle r_REPLAY(350,40,55,20);
        Text t2(350,40,"REPLAY");

        r_REPLAY.setColor(COLOR("red"));
        r_REPLAY.imprint();
        t2.imprint();
        int v=getClick();
        float x=v/65536;
        float y=v%65536;

        if(x<372.5&&x>327.5&&y<50&&y>30)
        {
            for(int i=1; i<7; i++)
            {
                for(int j=1; j<11; j++)
                {
                    Rectangle r1(90+40*(i),50+40*(j),35,35);
                    r1.setColor(COLOR("white"));
                    r1.setFill();
                    r1.imprint();
                }
            }
            rewind(history);

            for(int i=0; i<10; i++)
                for(int j=0; j<6; j++)
                    ob.prev[i][j]=0;
            while(!feof(history))
            {
                for(int i=0; i<10; i++)
                    for(int j=0; j<6; j++)
                        t[i][j]=0;
                fread(t,size,1,history);
                ob.display(t);
                wait(0.5);

            }
            wait(1);
            ob.display();
        }
        wait(1);

        for(int i=1; i<7; i++)
        {
            for(int j=1; j<11; j++)
            {
                Rectangle r(90+40*i,50+40*j,40,40);
                r.setColor(COLOR("white"));
                r.setFill();
                r.imprint();
            }
        }
        Rectangle r_undo1(150,40,45,20);
        r_undo1.setColor(COLOR("white"));
        r_undo1.setFill();
        r_undo1.imprint();
        Rectangle r_REPLAY1(350,40,55,20);
        r_REPLAY1.setColor(COLOR("white"));
        r_REPLAY1.setFill();
        r_REPLAY1.imprint();
        Rectangle next_GAME(250,200,300,20);
        next_GAME.setColor(COLOR("red"));
        next_GAME.imprint();
        Text t5(250,200,"Would you like to play again?");
        t5.imprint();
        Rectangle yes(200,230,30,20);
        Rectangle nO(300,230,20,20);
        yes.imprint();
        nO.imprint();
        Text t_no(300,230,"NO");
        Text t_yes(200,230,"YES");
        t_no.imprint();
        t_yes.imprint();

        do
        {
            int u=getClick();
            x=u/65536;
            y=u%65536;
            if((x<215)&&(x>185)&&(y<240)&&(y>220))
            {
                newgame=false;
                break;
            }
            else if((x<310)&&(x>290)&&(y<240)&&(y>220))
            {
                return 1;
            }
            else
            {
                continue;
            }
        }
        while(true);

    fclose(history);

    }
    while(true);

}
/*
End of code
We hope you liked the game.
Thank you.
*/




